import sys
import random
import datetime
from datetime import timedelta
import pytz
from tzlocal import get_localzone

from influxdb import InfluxDBClient

class influxaddress:
    def __init__(self, addr):
        self.series = ""
        self.field = ""
        self.tags = {}
        self.condition = ""
        
        bits = addr.split('|')

        #print str(bits)

        if len(bits)>2:
            self.field = bits[0]
            self.condition = bits[1]
            self.series = bits[2]
            tg = bits[1].split(',')
            for q in tg:
                v = q.split('=')
                self.tags[v[0]] = v[1].replace("'","")
            

defaultmeasurement = "driller"

function = "raw"
points=("temperature|drillid='1'|",)
start="2016-04-15 11:00:00"
end="2016-04-15 12:00:00"
grain=-20

database = "recordings"

print "Performing '" + function + "' query on " + str(points) + " between " + start + " and " + end 								

db = InfluxDBClient("54.206.58.61", 8086,"","","recordings")

tz = get_localzone()

#print dir(tz)
naive = tz.localize(datetime.datetime.strptime (start, "%Y-%m-%d %H:%M:%S"),is_dst=None)
sd = naive.astimezone (pytz.utc)

sdtx = sd.strftime("%Y-%m-%d %H:%M:%S")

naive = tz.localize(datetime.datetime.strptime (end, "%Y-%m-%d %H:%M:%S"),is_dst=None)
en = naive.astimezone (pytz.utc)

entx = en.strftime("%Y-%m-%d %H:%M:%S")

secdiff = (en - sd).seconds
chunksize = 0
if grain < 0:
	chunksize = secdiff / (-grain)
else:
	chunksize = grain

#sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
#ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

keyset = []
seriesset = []
fieldset = []

addresses = []
extragroup = ""

for p in points:
	ad = influxaddress(p)
	addresses.append(ad)
	if ad.field not in fieldset:
		fieldset.append(ad.field)
	if ad.series == None or ad.series == "":
		ad.series = defaultmeasurement
	if ad.series not in seriesset:
		seriesset.append(ad.series)
	if ad.condition not in keyset:
		keyset.append(ad.condition)
		for key in ad.tags:
			extragroup += "," + key
			#fieldset.append('_' + key)
	#for key in ad.tags:
		#if key not in keyset:
		#	keyset[key] = []
		#if ad.tags[key] not in keyset[key]:
		#	keyset[key].append(ad.tags[key])

#print str(fieldset)
#print str(seriesset)
#print str(keyset)

#extragroup= ""

if len(fieldset) > 10:
	fieldlist='*'
else:
	fieldlist = ""
	for f in fieldset:
		if fieldlist != "":
			fieldlist += ","
		
		if f[0] != '_':
			fieldlist += "MEDIAN(" + f + ") as " + f
		#else:
		#	fieldlist += f[1:]
		#	extragroup += "," + f[1:]

if len(seriesset) > 10:
	seriesset = collapseset(seriesset)
	if len(seriesset) > 10:
		serieslist = '*'
	else:
		serieslist= ""
		for s in serieslist:
			if serieslist != "":
				serieslist += ","
			serieslist += database + ".." + s
		#','.join(seriesset)
else:
	serieslist= ""
	for s in seriesset:
		if serieslist != "":
			serieslist += ","
		serieslist += database + ".." + s

if len(keyset) > 10:
	filter = ""
else:
	filter = ""
	for vv in keyset:
		if filter != "":
			filter += " OR "
		filter += "(" + vv + ")"

query = "SELECT " + fieldlist + " FROM " + serieslist + " WHERE time >= '" + sdtx + "' AND time <= '" + entx + "'"

if filter != "":
	query += " AND ( " + filter + " ) "
query += " GROUP BY time(" + str(chunksize) + "s)" + extragroup + " FILL(previous) ORDER BY time ASC "

print query

result = db.query(query)
#print str(result.raw)

for series in result.raw['series']:
	measurement = series['name']
	tags = series['tags']

	shortlist = []

	n = -1
	for addr in addresses:
		n = n+1
		if addr.series == measurement:
			#print "Checking Tags..."
			#print str(addr.tags) + " vs " + str(tags)
			matches = True
			for key in tags:
				#print "Trying " + key
				if key not in addr.tags:
					matches = False
					break
				else:
					#print "Working..."
					if addr.tags[key] != tags[key]:
						matches = False
						break
			if matches == False:
				continue

			shortlist.append((addr,n))

	for vl in series['values']:
		n=-1
		for xx in vl:
			n = n+1
			col = series['columns'][n]
			if col == 'time':
				tm = xx
			else:
				for sl in shortlist:
					if sl[0].field == col:
						value = xx
						print 'Value: ' + str(xx) + " for " + sl[0].series + "." + sl[0].field
