from __future__ import division
import sys
import random
import datetime
import time
import traceback
import math
from datetime import timedelta

class record:
	def __init__(self):
		self.timestamp = 0
		self.value = 0

class recrange:
	def __init__(self):
		self.frm = 0
		self.to = 0

class recordings:
	def __init__(self):
	    self.records = {}

	def record_strdate(self,rowid,timestamp,value):
		self.record(rowid,self.toepoch(timestamp),value)

	def record(self,rowid,timestamp,value):
		if rowid not in self.records:
			self.records[rowid] = []
			
	  	r = record()
	   	r.timestamp = timestamp
	   	r.value = value

	   	self.records[rowid].append(r)
	   	pass

	def toepoch(self,str):
		#tzinfo=pytz.utc
		tt = datetime.datetime.strptime(str,"%Y-%m-%d %H:%M:%S")
		return (tt - datetime.datetime.utcfromtimestamp(0)).total_seconds()

	def interpolate(self, sections, function, start, end):

		#print str(self.records)
		st = self.toepoch(start)
		en = self.toepoch(end)

		#print "Range: " + start + " to " + end
		#print "Range: " + str(st) + " to " + str(en)

		newrecords = {}
		minstamp = -1
		maxstamp = -1
		for key,value in self.records.iteritems():
			newrecords[key] = []
			#newrecords.append(key,[])

		starto = st
		endo = en
		#pnt = starto
		secondsper = (endo - starto) / sections

		#print "Seconds Per Segment: " + str(secondsper)

		rangeset = []
		bandstart = starto
		bandend = starto + secondsper
		for x in range(0,sections):
			rng = recrange()
			rng.frm = starto + (secondsper * x)
			rng.to = starto + (secondsper * (x+1))
			rangeset.append(rng)

		func = 0
		if function == "MIN":
			func = 1
		if function == "MAX":
			func = 2

		#For each channel, go through the records and determine which ones fit.
		for rs in rangeset:
			#print "Filling In Details From " + str(rs.frm) + " to " + str(rs.to)
			for rr in self.records:
				#print str(self.records[rr])
				hits = 0
				ttl = 0
				itms = 0
				intbefore = None
				intafter = None

				if (func == 1):
					ttl = -99999
				if (func == 2):
					ttl = 99999

				for r in self.records[rr]:
					#Find recordings that are within the time frame...
					#print "    Scanning " + str(r.timestamp)
					
					if r.timestamp < rs.frm:
						#print "      Setting As Previous"
						intbefore = r

					if r.timestamp > rs.to:
						#print "      Setting As Post"
						intafter = r
						break
						
					if (r.timestamp >= rs.frm) and (r.timestamp <= rs.to):
						#print "  Found " + str(r.value)
						itms=itms+1
						if (func == 0):
							ttl+=r.value
						else:
							if (func == 1):
								if (r.value > ttl):
									ttl = r.value
							else:
								if (r.value < ttl):
									ttl = r.value
						pass
					
				r = record()
				r.timestamp = rs.to
				r.value = ttl
				
				if itms == 0:
					#Interpolate based on previous records...
					#print "Interpolation Required"

					if intafter is None:
						r.value = intbefore.value
					else:
					#print str(intafter.timestamp)

						#Find the most recent record before the frame start
						#print "  Starting From " + str(intbefore.value) + " @ " + str(intbefore.timestamp) + " to " + str(intafter.value) + " @ " + str(intafter.timestamp)

						#Find the most recent record after the frame ends
						pc = (r.timestamp - intbefore.timestamp) / (intafter.timestamp - intbefore.timestamp)
						#print "  Percentage Through: " + str(pc)
						r.value = (intbefore.value * (1-pc)) + (intafter.value * (pc))
				else:
					if func == 0:
						ttl /= itms
						r.value = ttl

				newrecords[rr].append(r)

		self.records = newrecords

	def output_time(self):
		
		pass

	def output_channel(self):
		for key,value in self.records.iteritems():
			for vl in value:
				print str(key) + " - " + str(math.floor(vl.timestamp)) + " - " + str(vl.value)

if __name__ == "__main__":
    rec = recordings()

    #print dir(rec)

    rec.record_strdate(0,'2015-01-29 23:00:00',15)
    rec.record_strdate(0,'2015-02-01 08:00:00',20)
    rec.record_strdate(0,'2015-02-01 12:00:00',12.5)
    rec.interpolate(5,'AVG','2015-02-01 00:00:00','2015-02-02 00:00:00')
    
    rec.output_channel()
	