import sys
import random
import datetime
from datetime import timedelta

from ardi.driver import histdriverbase
import pymssql

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardihistdriver:
    def __init__(self):        
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.query = ""
        self.stamp = ""
        self.table = ""
        self.lookup = ""
        self.value = ""
        self.filter = ""
        self.lookuptable = {}

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        filter = ""

        #print "Raw Address"

        if len(bits) >= 6:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]
            self.table = bits[5]
            self.lookup = bits[6]
            self.stamp = bits[7]
            self.value = bits[8]
        if len(bits) > 9:
            filter = bits[9]

    def Connect(self):
        try:		
        	self.db = pymssql.connect(self.host + ":" + self.port,self.username,self.password,self.database)
        	self.connected = True        
        	return True
        except:
        	return False		

    def Disconnect(self):
        try:			
        	self.con.close()
        except:
        	pass        
        
    def Query(self, points, start,end,function,grain):
		#print "Performing '" + function + "' query on " + str(points) + " between " + start + " and " + end 								

		sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
		ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

		#OK - fabricate an SQL query...	
		#SELECT DATE_ADD(".$db->quote($rangefrom).",INTERVAL (CEIL(TIMESTAMPDIFF(SECOND,".$db->quote($rangefrom).",stamp) / ".$gx.") * ".$gx.") SECOND) as ostamp, AVG(value) as value
		func = "AVG"
		if (function == "min")
			func = "MIN"
		if (function == "max")
			func = "MAX"
		
		self.query = "SELECT " + self.stamp + "," + self.lookup + "," + self.value + " FROM " + self.table + " WHERE "
		if grain != 0:
			self.query = "SELECT DATE_ADD('" + str(sd) + "',INTERVAL (CEIL(TIMESTAMPDIFF(SECOND,'" + str(sd) + "'," + self.stamp + ") / " + str(grain) + ") * " + str(grain) + ") SECOND) as ostamp, " + self.lookup + " as lookup,"+ func + "(" + self.value + ") as value "
			
		if self.filter != "":
			self.query += "( " + self.filter + " ) AND "
			
		self.query += "( " + self.stamp + " >= '" + str(sd) + "' AND " + self.stamp + " <= '" + str(ed) + "' )"

		#Filter for point list...
		self.query += " AND " + self.lookup + " IN ( "
		x = 0
		for p in self.core.pointlist:
			if x > 0:
				self.query += ","
			self.query += "'" + p.address + "'"
			x = x + 1

		self.query += " )"
		if grain != 0:
			self.query += " GROUP BY ostamp, lookup ORDER BY ostamp,lookup"
		else:
			self.query += " ORDER BY " + self.stamp + " ASC"

		#print "Submitting Query: " + self.query
		
		out = "Name, Timestamp, Value\r\n"
		csr = self.db.cursor()
		#timing = time.time()

		csr.execute(self.query)
		if grain != 0:
			for row in csr:
				out += str(row[1]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"
		else:
			for row in csr:
				out += str(row[1]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"

		print out

		return out.encode('ascii')
		            
class driverfactory:
    def createinstance(self):
        return ardihistdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)