import sys
import random
import datetime
from datetime import timedelta

from ardi.driver import histdriverbase
#import pymssql
from suds.client import Client
from suds.bindings import binding

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardihistdriver:
    def __init__(self):              
        self.host = ""
        self.prefix = ""
        self.lookuptable = {}
        self.client = None

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        self.address = bits[0]
        if (self.address[4:7] == "://"):
               self.address = self.address[7:]
            
    def Connect(self):
        url = 'http://' + self.address + '/PIWebServices/PITimeSeries.svc?wsdl'
        self.core.logger.info("Loading " + url)

		try:
			self.client = Client(url)
		except Exception as e:
			try:
				self.core.exception('Failure During Connect: ' + str(e))
			except Exception as ex:
				print "Exception Handling Exception: " + str(ex)
			return
		
		try:
			ver = self.client.service.GetProductVersion()
		except Exception as e:
			self.core.exception('Failure During GetProductVersion: ' + str(e))
			return
		
		self.core.logger.info("Connected to PI Web Services version " + ver)		

    def Disconnect(self):
        try:			
        	self.con.close()
        except:
        	pass        
        
    def Query(self, points, start,end,function,grain):
		#print "Performing '" + function + "' query on " + str(points) + " between " + start + " and " + end 								

		sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
		ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

		#OK - fabricate an SQL query...	
		func = "AVG"
		if (function == "min")
			func = "MIN"
		if (function == "max")
			func = "MAX"

		out = "Name, Timestamp, Value\r\n"

		strset = self.client.factory.create('ArrayOfString')

		strset.string = []

		for itm in self.core.pointlist:
			strset.string.append(self.prefix + itm.address)

		self.core.logger.info("Getting Initial Data Snapshot")

		try:
			results = self.client.service.GetPISnapshotData(strset)
		except Exception as e:
			self.core.logger.info("Failed Snapshot Request : " + str(strset))
			self.core.exception("Exception In Snapshot Request : " + str(e))
			try:
				for point in core.pointlist:
					self.core.UpdateData(point.code,"^")
			except:
				pass
			return

		indx = 0
		for res in results.TimeSeries:
			val = "0"
			if res.TimedValues is None:
				val="^"
				if res._ErrDesc is not None:
					self.core.logger.info(str(self.core.pointlist[indx].address + ": " + str(res._ErrDesc)))
			else:
				try:
					#self.core.logger.info("Reading Timed Value: " + str(dir(res.TimedValues[0][0])))
					val = res.TimedValues[0][0].value
					self.fetchset.append(indx)
					self.core.logger.info(self.core.pointlist[indx].address + " = " + str(val))
				except Exception as e:
					self.core.logger.error("Couldn't Read " + self.core.pointlist[indx].address + " - " + str(e))

			#self.core.logger.info("Updating " + self.core.pointlist[indx].code + " with " + str(val))
			self.core.UpdateData(self.core.pointlist[indx].code,str(val))
				
			indx = indx + 1

		if grain != 0:
			for row in csr:
				out += str(row[1]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"
		else:
			for row in csr:
				out += str(row[1]) + "," + str(row[0]) + "," + str(row[2]) + "\r\n"

		print out

		return out.encode('ascii')
		            
class driverfactory:
    def createinstance(self):
        return ardihistdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)