import sys
import random
import datetime
import math
from datetime import timedelta

from ardi.driver import histdriverbase

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class ardisimdriver:
    def __init__(self):
        self.path = ""
        self.samples=0
        self.per=75
	
    def SetAddress(self, addr):
        self.path = addr
		
    def Connect(self):
		try:		
			#self.con = sql.connect(self.path)
			return True
		except:
			return False		
		
    def Disconnect(self):
		#self.con.close()
		pass

    def Remap(self):
		n = 0
		for point in self.core.pointlist:
		    point.address = str(n)
		    n = n + 1

    def RunQuery(self,query):
		changepersec = 0.002

		self.core.logger.info("Query Started: '" + query.function + "' between " + str(query.sd) + " and " + str(query.ed) + " - " + str(query.grain) + " samples")

		sdbase = ((query.sd - datetime.datetime(1970,1,1)).total_seconds() * changepersec) % 90

		sd = query.sd
		ed = query.ed

		samplebase = sdbase
		n=0
		if query.sd == query.ed:
			for p in query.addresses:
				val = (round(math.sin(samplebase + (n * 0.01)),3) * 50) + 50
				query.AddLine(p,sd,val)
				n= n + 1
			return query.Finish()

		diff = ed - sd

		secs = diff.total_seconds()
		grain = query.grain

		if query.function == "changes":
			grain = 1

		count = 50
		
		if int(grain) > 0:
			count = secs / int(grain)
		else:
			count = -int(grain)
			if count <= 1:	
				count = 2;

		if int(grain) < 0:
			count = -int(grain)

		#print(str(query.points))

		stepsize = secs / count
		step = timedelta(seconds=stepsize)

		for x in range(0,int(count)):
			n = 0
			for p in query.addresses:
				val = (round(math.sin(samplebase + (n * 0.01)),3) * 50) + 50
				#print "Adding Line..." + p + " - " + str(val)
				query.AddLine(p,sd,val)
				n= n + 1
			sd = sd + step
			
			samplebase = samplebase + (changepersec * stepsize)

		
		return query.Finish()
		            
class driverfactory:
    def createinstance(self):
        return ardisimdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)