import sys
import random
import datetime
import math
import os
from datetime import timedelta

from ardi.driver import histdriverbase

def fixdate(dt):
	ps = dt.find('.')
	if ps > -1:
		return dt[0:ps]
	return dt

class arditextdriver:
	def __init__(self):
		self.path = ""
		self.lookup = []
		self.tz = "UTC"

	def SetAddress(self, addr):
		bits = addr.split('^')
		self.filename = bits[0]
		self.namecol = int(bits[1])-1
		self.valuecol = int(bits[2])-1
		self.datecol = int(bits[3])-1
		self.tz = bits[4];
		self.delimiter = "\t"
		if self.delimiter == "\\t":
			self.delimiter = "\t"

	def Connect(self):
		if os.path.isfile(self.filename):
			self.connected = True
			return True
		else:
			return False	

	def Disconnect(self):
		self.connected = False
		pass

	def RunQuery(self,query):
		any = False
		lastvalue = {}

		query.SetDateFormat(self.tz,"1",False)

		with open(self.filename,'r') as f:
			for line in f:
				#print line
				bits = line.split(self.delimiter)
				
				#Is this date in the range?
				ldt = bits[self.datecol]
				TT = ldt#str(datetime.datetime.strptime( ldt, "%Y-%m-%d %H:%M:%S" ))
				if TT < query.sd:
					lastvalue[bits[self.namecol]] = str(bits[self.valuecol]).strip()
					continue

				if TT > query.ed:
					break
				
				if bits[self.namecol] in query.addresses:
					vl = str(bits[self.valuecol]).strip()
					query.AddLine(bits[self.namecol],ldt,vl)
					#out = out + self.core.AddRecord(n,ldt,vl,self.namecol)
					any = True

		if any == False:
			for ky,vl in lastvalue.iteritems():
				query.AddLine(ky,ldt,vl)
					#out = out + self.core.AddRecord(n,sd,vl,ky)

		vv = query.Finish()
		#print vv
		return vv
		

	#def Query(self, points, start,end,function,grain,first):

	#	changepersec = 0.002;
	#	self.core.logger.info("Query Started: '" + function + "' between " + start + " and " + end + " - " + str(grain) + " samples") 								

	#	sd = datetime.datetime.strptime( start, "%Y-%m-%d %H:%M:%S" )
	#	ed = datetime.datetime.strptime( end, "%Y-%m-%d %H:%M:%S" )

	#	out = ""

	#	n = 0
	#	lookupid = {}
	#	lastvalue = {}
	#	for p in points:
	#		#lastvalue[p] = -99999
	#		lookupid[p] = n
	#		n=n+1
	#	#	lookup[p.address] = p

	#	any = False

	#	with open(self.filename,'r') as f:
	#		for line in f:
	#			#print line
	#			bits = line.split(self.delimiter)
	#			
	#			#Is this date in the range?
	#			ldt = bits[self.datecol]
	#			TT = datetime.datetime.strptime( ldt, "%Y-%m-%d %H:%M:%S" )
	#			if TT < sd:
	#				lastvalue[bits[self.namecol]] = str(bits[self.valuecol]).strip()
	#				continue
	#
	#			if TT > ed:
	#				break
	#			
	#			if bits[self.namecol] in self.lookup:
	#				vl = str(bits[self.valuecol]).strip()
	#				n = lookupid[bits[self.namecol]]
	#				out = out + self.core.AddRecord(n,ldt,vl,self.namecol)
	#				any = True
	#
	#	if any == False:
	#		for ky,vl in lastvalue.iteritems():
	#			if ky in lookupid:
	#				n = lookupid[ky]
	#				out = out + self.core.AddRecord(n,sd,vl,ky)
	#
	#	return out.encode('ascii')

class driverfactory:
    def createinstance(self):
        return arditextdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = histdriverbase.historian()
    base.start(sdf)