import sys

from ardi.driver import drivercore,driverbase
import pymssql

#import mysql.connector
#from mysql.connector import errorcode
#import mysqldb

class sqlquery:
    def __init__(self):
        self.stampfield = ""
        self.tablename = ""
        self.qstring = ""
        self.condition = ""
        self.fields = ()
        self.codes = ()

    def build(self):
        #print "Building Query String From " + self.tablename + " / " + self.stampfield
        self.qstring = "SELECT TOP 1 " + (','.join(self.fields))        
        self.qstring += " FROM " + self.tablename
        if self.condition <> "":
            self.qstring += " WHERE (" + self.condition + ")"
        self.qstring += " ORDER BY " + self.stampfield + " DESC"
        #print "   " + self.qstring    

class sqladdress:
    def __init__(self, addr):
        self.tablename = ""
        self.fieldname = ""
        self.stampfield = ""
        self.condition = ""

        bits = addr.split('|')
        if len(bits)>=2:
            self.fieldname = bits[0]
            self.tablename = bits[1]            
            if len(bits)>=3:
                self.stampfield = bits[2]
            if len(bits)>=4:
                self.condition = bits[3]
                            
class ardimysqldriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 5
        self.subscription = ''
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.queries = ()

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")        
        if len(bits) >= 5:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]        
    
    def Connect(self):
        try:
            #print "Connecting..."
            #self.db = mysql.connector.connect(user=self.username,password=self.password,host=self.host,database=self.database)
            self.db = pymssql.connect(self.host,self.username,self.password,self.database)
            self.connected = True        
        except:
            #print "Error Connecting to Database!"
            return False
        return True

    def Optimise(self):

        #OK - collect all of the addresses with a common table...
        self.queries = ()

        for itm in self.core.pointlist:
            addr = sqladdress(itm.address)
            found = False            
            for existing in self.queries:
                if (addr.tablename == existing.tablename):
                                                            
                    #Found a table - make sure it doesn't have an incompatible filter...
                    if addr.condition <> existing.condition:
                        continue
                        
                    found = True
                    existing.fields = existing.fields + (addr.fieldname,)
                    existing.codes += (itm.code,)
                    break
            if found == False:
                s = sqlquery()
                #s.fieldname = addr.fieldname
                s.condition = addr.condition
                s.tablename = addr.tablename
                s.fields += (addr.fieldname,)
                s.codes += (itm.code,)
                if addr.stampfield <> "":
                    s.stampfield = addr.stampfield

                #print "Added Query: " + s.fieldname + " / " + s.tablename
                self.queries = self.queries + (s,)

        #Build Query Strings...
        for itm in self.queries:
            itm.build()

    def Disconnect(self):
        self.connected = False
        self.db.close()
        
    def Poll(self):
        for itm in self.queries:            
            csr = self.db.cursor()            
            #try:
            if True:
                print "Querying: " + itm.qstring               
                csr.execute(itm.qstring)                
                for row in csr:                    
                    x=-1
                    for piece in row:
                        x = x+1
                        #print itm.codes[x] + " = " + str(piece)
                        self.core.UpdateData(itm.codes[x],str(piece))

                self.db.commit()                     
                csr.close()
            #except:
            #    #Mark all as bad...
            #    pass                        

class driverfactory:
    def createinstance(self):
        return ardimysqldriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)