import sys
import time

from ardi.driver import drivercore,driverbase
import pymssql

#import mysql.connector
#from mysql.connector import errorcode
#import mysqldb

class sqladdress:
    def __init__(self, addr):
        self.conditionvalue = ""        
                            
class ardimysqldriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 2
        self.subscription = ''
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.query = ""
        self.lookuptable = {}

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        filter = ""

        #print "Raw Address"

        if len(bits) >= 6:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]
            table = bits[5]
            lookup = bits[6]
            stamp = bits[7]
            value = bits[8]
        if len(bits) > 9:
            filter = bits[9]

        self.stamp = stamp

        if stamp == "":
            self.query = "SELECT " + lookup + "," + value + " FROM " + table
            if filter != "":
                self.query += " WHERE ( " + filter + " )"            
        else:
            self.getdatequery = "SELECT TOP 1 " + stamp + " FROM " + table + " ORDER BY " + stamp + " DESC";
            self.query = "SELECT " + lookup + "," + value + " FROM " + table + " WHERE "
            if filter != "":
                self.query += "( " + filter + " ) AND "
            self.query += "stamp>='[stamp]'"

        self.core.logger.warning("Using Query: " + self.query);   
        #print "Final Query = " + self.query
    
    def Connect(self):
        try:
            self.core.logger.info("Connecting to " + self.host + ":" + self.port + " / " + self.database + " as " + self.username )
            self.db = pymssql.connect(host=self.host + ":" + self.port,user=self.username,password=self.password,database=self.database,login_timeout=10)
            self.connected = True        
        except StandardError as err:
            self.core.logger.error(str(err))
            #print err
            return False
        except:            
            return False
        return True

    def Optimise(self):        
        self.lookuptable = {}
        x=-1
        for itm in self.core.pointlist:
            x = x+1
            self.lookuptable[str(itm.address)] = x     

    def Disconnect(self):
        self.connected = False
        self.db.close()
        
    def Poll(self):
        try:

            #print "Polling!"

            qry = self.query
            if self.stamp != "":
                csr = self.db.cursor()
                timing = time.time()
                csr.execute(self.getdatequery)
                for row in csr:
                    v = str(row[0])
                    ps = v.find('.')
                    v = v[0:ps]
                    qry = qry.replace("[" + "stamp" + "]",v)

            #print qry

            csr = self.db.cursor()
            timing = time.time()            
            csr.execute(qry)                
            for row in csr:
                if str(row[0]) in self.lookuptable:
                    self.core.NewData(str(row[0]),str(row[1]))
                    #self.core.UpdateData(self.core.pointlist[self.lookuptable[str(row[0])]].code,str(row[1]))
                    
            self.db.commit()                     
            csr.close()
        except StandardError as err:
            try:
                self.core.logger.error('Query Failed: ' + str(err))
                self.Disconnect()
                self.Connect()
            except:
                self.core.logger.error('Failure')

class driverfactory:
    def createinstance(self):
        return ardimysqldriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
