import sys
import time

from ardi.driver import drivercore,driverbase
import MySQLdb

#import mysql.connector
#from mysql.connector import errorcode
#import mysqldb

class sqladdress:
    def __init__(self, addr):
        self.conditionvalue = ""        
                            
class ardimysqldriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 10
        self.subscription = ''
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.query = ""
        self.stamp = ""
        self.laststamp = ""
        self.filter = ""
        self.first = True
        self.lookuptable = {}

    def SetAddress(self, addr):
        self.connected = False
        if addr is None:
            return;
        bits = addr.split(":")
        filter = ""

        print "Raw Address " + addr

        if len(bits) >= 6:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]
            table = bits[5]
            lookup = bits[6]
            stamp = bits[7]
            value = bits[8]
        if len(bits) > 9:
            filter = bits[9]

        self.stamp = stamp
        self.table = table
        self.lookup = lookup
        if self.stamp == "":
            self.stamp = stamp
            self.query = "SELECT " + lookup + "," + value + " FROM " + table
            if filter != "":
                self.query += " WHERE ( " + filter + " )"            
        else:
            self.query = "SELECT " + lookup + "," + value + ", " + stamp + " FROM " + table + " WHERE "
            if filter != "":
                self.query += " ( " + filter + " ) AND "
    
    def Connect(self):
        try:            
            self.db = MySQLdb.connect(self.host,self.username,self.password,self.database,port=int(self.port))
            self.connected = True        
        except StandardError as err:
            self.core.logger.error(err[1])
            return False
        except:            
            return False
        return True

    def Optimise(self):
        self.lookuptable = {}
        x=-1
        for itm in self.core.pointlist:
            x = x+1
            self.lookuptable[itm.address] = x

        self.first = True
        if self.stamp != "":
            csr = self.db.cursor()
            csr.execute("SELECT MAX(" + self.stamp + ") FROM " + self.table)
            for row in csr:
                self.laststamp = row[0]

            self.first = True
            self.db.commit()                     
            csr.close()
            self.core.logger.info("Most Recent Date Stamp: " + str(self.laststamp))

    def Disconnect(self):
        self.connected = False
        self.db.close()
        
    def Poll(self):
        qry = self.query
        #print "WTF - " + self.stamp
        if self.stamp != "":
            #print "Stamping..."
            vv = "'" + str(self.laststamp) + "'"
            try:
                s = float(str(self.laststamp))
                vv = str(self.laststamp)
            except ValueError:
                pass
            
            if self.first == True:
                qry = self.query + self.stamp + " >= " + vv
                self.first = False
            else:
                qry = self.query + self.stamp + " > " + vv

            #self.core.logger.info("Stamp Query: " + qry)
        try:
            #print "Standard"
            csr = self.db.cursor()
            timing = time.time()
            #print qry
            csr.execute(qry)
            for row in csr:
                if row[0] in self.lookuptable:
                    self.core.NewData(str(row[0]),str(row[1]))
                    if self.stamp != "":
                        if row[2] > self.laststamp:
                            self.laststamp = row[2]

            self.db.commit()                     
            csr.close()        
        except StandardError as err:
            try:
                if (str(err[1]) == "MySQL server has gone away") or (str(err[1]) == ""):
                    self.core.logger.error('Data Connection Lost')
                    try:
                        self.db.close()
                    except:
                        pass
                    self.connected = False
                    return
                self.core.logger.error('Query Failed: ' + err[1] + " in " + self.query)
            except:
                self.core.logger.error('Failure')

class driverfactory:
    def createinstance(self):
        return ardimysqldriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
