import sys

from ardi.driver import drivercore,driverbase
import MySQLdb

#import mysql.connector
#from mysql.connector import errorcode
#import mysqldb

class sqladdress:
    def __init__(self, addr):
        self.conditionvalue = ""        
                            
class ardimysqldriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 5
        self.subscription = ''
        self.port = 0
        self.db = None        
        self.host = ""
        self.database = ""
        self.username = ""
        self.password = ""
        self.query = ""

    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        filter = ""

        #print "Raw Address"

        if len(bits) >= 6:
            self.host = bits[0]
            self.port = bits[1]
            self.database = bits[2]
            self.username = bits[3]
            self.password = bits[4]
            table = bits[5]
            lookup = bits[6]
            stamp = bits[7]
            value = bits[8]
        if len(bits) > 9:
            filter = bits[9]

        if stamp == "":
            self.query = "SELECT " + lookup + "," + value + " FROM " + table
            if filter != "":
                self.query += " WHERE ( " + filter + " )"            
        else:                        
            self.query = "SELECT * FROM ( SELECT " + lookup + "," + value + " FROM " + table
            if filter != "":
                self.query += " WHERE ( " + filter + " ) "
            self.query += " ORDER BY " + stamp + " DESC ) as t1 GROUP BY " + lookup;

        self.core.logger.warning("Using Query: " + self.query);   
        #print "Final Query = " + self.query
    
    def Connect(self):
        try:            
            self.db = MySQLdb.connect(self.host,self.username,self.password,self.database)
            self.connected = True        
        except StandardError as err:
            self.core.logger.error(err[1])
            #print err
            return False
        except:            
            return False
        return True

    def Optimise(self):        
        pass        

    def Disconnect(self):
        self.connected = False
        self.db.close()
        
    def Poll(self):
        try:
            csr = self.db.cursor()        
            #print "Querying: " + self.query          
            csr.execute(self.query)                
            for row in csr:
                for itm in self.core.pointlist:
                    #print "Comparing " + str(itm.address) + " to " + str(row[0])
                    if str(itm.address) == str(row[0]):
                        #print "Updating Data " + str(itm.code) + " = " + str(row[1])
                        self.core.UpdateData(itm.code,str(row[1]))

            self.db.commit()                     
            csr.close()
        except StandardError as err:
            self.core.logger.error('Query Failed: ' + err[1])            

class driverfactory:
    def createinstance(self):
        return ardimysqldriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
