import sys

from ardi.driver import drivercore,driverbase

import OpenOPC

class ardiopcdriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.pollinterval = 30
        self.group = ''
	
    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split(":")
        self.ip = bits[0]
        self.servername = bits[1]
    
    def Connect(self):
		try:		
			self.opc = OpenOPC.open_client(self.ip)
			self.opc.connect(self.servername)		
			self.connected = True        
		except:
			return False
		return True
		
    def Optimise(self):
		if self.group != '':
			self.opc.remove('ardidaq')
		
		queryset = []
		for itm in self.core.pointlist:
			queryset.append(itm.address)
		
		#print queryset
		
		resp = self.opc.read(queryset,group='ardidaq')
		self.group = 'ardidaq'			
		
		#print resp
        
    def Disconnect(self):
        self.connected = False
        if self.group != '':
			self.opc.remove('ardidaq')
        self.opc.close()
        
    def Poll(self):

		try:
			values = self.opc.read(group='ardidaq')
		except:
			try:
				self.opc.remove('ardidaq')
			except:
				pass
			try:
				self.opc.close()
			except:
				pass
				
			self.connected = False
			return
			
		#print values
        
		indx = 0
		for itm in self.core.pointlist:
			quality = values[indx][2]			
			if (quality == 'Good'):	
				val = values[indx][1]						
				self.core.UpdateData(itm.code,str(val))
			else:
				self.core.UpdateData(itm.code,'^')
			indx = indx + 1
            
class driverfactory:
    def createinstance(self):
        return ardiopcdriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)