import sys
import random
import traceback
import math

from ardi.driver import drivercore, driverbase

class ardiranddriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.samples = 0
        self.perrequest = 0.25
    
    def SetAddress(self, addr):
        self.connected = False
    
    def Connect(self):
        self.connected = True
        return True
    
    def Disconnect(self):
        self.connected = False
        
    def Optimise(self):
        pass

    def Remap(self):
        n = 0
        for point in self.core.pointlist:
            point.address = n
            n = n + 1
        
    def Poll(self):

        #print 'Polling!'
        i=0
        for point in self.core.pointlist:
            try:               
                val = (math.sin(self.samples + (i*0.01)) * 50)+50#random.random()*100
                self.core.UpdateData(point.code,str(val))
                #print val
                i=i+1
            except:
                traceback.print_exc()
                pass
        self.samples = self.samples + self.perrequest

class driverfactory:
    def createinstance(self):
        return ardiranddriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
    