import sys
import random
import traceback
import math
import os

from ardi.driver import drivercore, driverbase

class ardiranddriver:
    def __init__(self):
        self.connected = False
        self.polling = True
        self.samples = 0
        self.perrequest = 0.25
        self.filename = ""
        self.delimiter = "\t"
        self.lookup = {}
    
    def SetAddress(self, addr):
        self.connected = False
        bits = addr.split('^')
        self.filename = bits[0]
        self.delimiter = bits[1]
        if self.delimiter == "\\t":
            self.delimiter = "\t"
    
    def Connect(self):
        if os.path.isfile(self.filename):
            self.connected = True
            return True
        else:
            return False
    
    def Disconnect(self):
        self.connected = False
        
    def Optimise(self):
        for point in self.core.pointlist:
            try:               
                self.lookup[point.address] = point.code
            except:
                traceback.print_exc()
                pass
        
    def Poll(self):
        #print str(self.lookup)
        with open(self.filename,'r') as f:
            for line in f:
                bits = line.split(self.delimiter)

                #print "Checking '" + bits[0] + "'..."
                
                if bits[0] in self.lookup:
                    vl = str(bits[1]).strip()
                    #print("Found Match: " + bits[0])
                    self.core.NewData(bits[0],vl)
                    #self.core.UpdateData(self.lookup[bits[0]],vl)

class driverfactory:
    def createinstance(self):
        return ardiranddriver()
            
if __name__ == "__main__":
    sdf = driverfactory()
    base = driverbase.ardidriver()
    base.start(sdf)
    